package cn.wustlinghang.wusthelper.rpc.exception;

public class RpcException extends RuntimeException {
    protected final int code;

    public RpcException(int code, String message) {
        super(message);
        this.code = code;
    }

    public RpcException(int code) {
        this(code, String.valueOf(code));
    }

    public RpcException(int module, int type, int exceptionCode) {
        this((module * 1000_0000) + (type * 1_0000) + (exceptionCode));
    }

    public RpcException(int module, int type, int exceptionCode, String message) {
        this((module * 1000_0000) + (type * 1_0000) + (exceptionCode), message);
    }

    public int getCode() {
        return code;
    }

    public static RpcException ApiNotImplement() {
        return new RpcException(-1, "接口未实现");
    }
}
