package cn.wustlinghang.wusthelper.internal.library.api.json;

import cn.wustlinghang.mywust.core.parser.undergraduate.UndergradCreditStatusParser;
import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradCreditStatusApiService;
import cn.wustlinghang.mywust.data.global.StudentInfo;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import cn.wustlinghang.mywust.network.RequestClientOption;
import cn.wustlinghang.wusthelper.rpc.response.RpcResponse;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.io.IOException;

@Path("/credit_status")
@ApplicationScoped
public class CreditStatusApi {
    private final UndergradCreditStatusApiService creditStatusApiService;
    private final UndergradCreditStatusParser creditStatusParser;

    private final RequestClientOption option;

    public CreditStatusApi(UndergradCreditStatusApiService creditStatusApiService,
                           UndergradCreditStatusParser creditStatusParser,
                           RequestClientOption option) {
        this.creditStatusApiService = creditStatusApiService;
        this.creditStatusParser = creditStatusParser;
        this.option = option;
    }

    @GET
    @Path("/")
    public String get(String cookie) throws IOException, ApiException, ParseException {
        String html =  creditStatusApiService.getPage(cookie, option, false);
        return this.parse(html);
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws IOException, ApiException {
        return creditStatusApiService.getPage(cookie, option, false);
    }

    @POST
    @Path("/parse")
    public String parse(String html) throws ParseException {
        return creditStatusParser.parse(html);
    }
}
