package cn.wustlinghang.wusthelper.internal.library.api.json;

import cn.wustlinghang.mywust.core.parser.undergraduate.UndergradScoreParser;
import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradScoreApiService;
import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.mywust.data.global.StudentInfo;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import cn.wustlinghang.wusthelper.rpc.response.RpcResponse;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.io.IOException;
import java.util.List;

@Path("/score")
@ApplicationScoped
public class ScoreApi {
    private final UndergradScoreApiService scoreApiService;
    private final UndergradScoreParser scoreParser;

    public ScoreApi(UndergradScoreApiService scoreApiService, UndergradScoreParser scoreParser) {
        this.scoreApiService = scoreApiService;
        this.scoreParser = scoreParser;
    }

    @GET
    @Path("/")
    public List<Score> get(String cookie) throws IOException, ApiException, ParseException {
        String html =  scoreApiService.getPage(cookie);
        return this.parse(html);
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws IOException, ApiException {
        return scoreApiService.getPage(cookie);
    }

    @POST
    @Path("/parse")
    public List<Score> parse(String html) throws ParseException {
        return scoreParser.parse(html);
    }
}
