package cn.wustlinghang.wusthelper.internal.physics.api.json;

import cn.wustlinghang.mywust.core.parser.undergraduate.UndergradTrainingPlanPageParser;
import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradTrainingPlanApiService;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.io.IOException;

@Path("/training_plan")
@ApplicationScoped
public class TrainingPlanApi {
    private final UndergradTrainingPlanApiService trainingPlanApiService;
    private final UndergradTrainingPlanPageParser trainingPlanPageParser;

    public TrainingPlanApi(UndergradTrainingPlanApiService trainingPlanApiService,
                           UndergradTrainingPlanPageParser trainingPlanPageParser) {
        this.trainingPlanApiService = trainingPlanApiService;
        this.trainingPlanPageParser = trainingPlanPageParser;
    }

    @GET
    @Path("/")
    public String get(String cookie) throws IOException, ApiException, ParseException {
        String html =  trainingPlanApiService.getPage(cookie);
        return this.parse(html);
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws IOException, ApiException {
        return trainingPlanApiService.getPage(cookie);
    }

    @POST
    @Path("/parse")
    public String parse(String html) throws ParseException {
        return trainingPlanPageParser.parse(html);
    }
}
